Subject: Re: [net-next 14/15] net/mlx5: Light probe local SFs

From: Jakub Kicinski <[email-masked]>
Date: Tue, 13 Jun 2023 19:05:52 -0700

On Tue, 13 Jun 2023 16:32:07 -0700 Saeed Mahameed wrote:
> On 12 Jun 10:51, Jakub Kicinski wrote:
> >On Sat, 10 Jun 2023 21:15:57 -0700 Saeed Mahameed wrote:  
> >> I think we did talk about this, but after internal research we prefer to
> >> avoid adding additional knobs, unless you insist :) ..
> >> I think we already did a research and we feel that all of our users are
> >> going to re-configure the SF anyway, so why not make all SFs start with
> >> "blank state" ?  
> >
> >In the container world, at least, I would have thought that the
> >management daemon gets a full spec of the container its starting
> >upfront. So going thru this spawn / config / futz / reset cycle
> >is pure boilerplate pain.
> 
> That's the point of the series. create / config / spawn.
> 
> personally I like that the SF object is created blank, with dev handles
> (devlink/aux) to configure it, and spawn it when ready.

I think we had this discussion before, wasn't the initial proposal for SF
along those lines? And we're slowly trending back towards ports in
uninitialized state. It's okay, too late now.

> I don't see a point of having an extra "blank state" devlink param.

Yeah, the param would be worse of both worlds. 
We'll need to ensure consistency in other vendors, tho.

> >What use cases are you considering? More VM-oriented?
> 
> Mostly container oriented, and selecting the ULP stacks, e.g RDMA, VDPA,
> virtio, netdev, etc .. 

Odd, okay.

> >> This was the first SF aux dev to be created on the system. :/
> >>
> >> It's a mess ha...
> >>
> >> Maybe we need to set the SF aux device index the same as the user index.
> >> But the HW/port index will always be different, otherwise we will need a map
> >> inside the driver.  
> >
> >It'd be best to synchronously return to the user what the ID of the
> >allocated entity is. It should be possible with some core changes to
> >rig up devlink to return the sfnum and port ID. But IDK about the new
> >devlink instance :(  
> 
> I think that's possible, let me ask the team to take a shot at this.. 
> 
> I am not sure I understand what you mean by "new devlink instance".
> 
> SF creation will result in spawning two devlink handles, the SF function port of
> on the eswitch and the SF device devlink instance..

Yes, I mean "SF device devlink instance" by "new devlink instance".

In theory this should all be doable with netlink. NLM_F_ECHO should
loop all notifications back to the requester. The tricky part is
catching the notifications, I'm guessing, because in theory the devlink
instance spawning may be async for locking reasons? Hopefully not,
then it's easy..